<!doctype html>
<html lang="en">

	<head>
		<meta charset="utf-8">

			<title>Regular Expressions </title>

			<meta name="description" content="Regular Expressions (Search)">
		<meta name="author" content="José Calvo Tello">

		<meta name="apple-mobile-web-app-capable" content="yes">
		<meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

		<meta name="viewport" content="width=device-width, initial-scale=1.0">

		<link rel="stylesheet" href="../../lib/reveal/dist/reset.css">
		<link rel="stylesheet" href="../../lib/reveal/dist/reveal.css">
		<link rel="stylesheet" href="../../lib/reveal/dist/theme/sky.css" id="theme">
		<link rel="stylesheet" href="custom.css">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="../../lib/reveal/plugin/highlight/monokai.css" id="highlight-theme">
	</head>

	<body>

        <div class="reveal">
            <div class="slides">
              
				<section data-markdown="" data-separator="^\n---\n" data-separator-vertical="^\n--\n" data-charset="utf-8">
					<script type="text/template">
<!-- .slide: class="firstSlide" -->			
## 4. Regular Expressions

<br />

##### Library Carpentries workshop für subject specialists, SUB Göttingen, 28.02.2022

<hr />

#### Dr. José Calvo Tello
##### Niedersächsische Staats- und Universitätsbibliothek (SUB) Göttingen 

<hr />


<!--https://jose.calvotello.pages.gwdg.de/slides/talks/20201117_DH_Romanistik/-->

<img data-src="./img/digital humanities in the library_replicate-prediction-3skxyw6hxvfbpcvkrl47cob4fm.png" width="300"/>

---

# 4. Regular Expressions (Search)

--

# Search

* Search for patterns in digital programms and digital documents
* Ctr + F
* GUK, Beispiel:
	* tit französisch?
	* tit digitale  geisteswissenschaften vs. digital? geisteswissenschaft?
* Many enviroments show slight differences

--

# Regular expressions are

* a concept and an implementation
* used in many different programming environments
* used for sophisticated pattern matching 
* an incredibly powerful tool to find, manage, and transform data and files
* A regular expression (also: “regex”) is a method of using a sequence of characters to define a search to match strings

--

# Data
* Basisklassifikation (BK) as plaintext

--

## Notepad++
* Ctr + C
* Find, Replace, Find in Files, Find Projects, Mark
* Options
	* "Regular expression" **selected**
	* "Match case" **unselected**
	* "Matches newlines" **unselected**

### Exercise (without Regex)
* In BK search for the word "Garten"
* In BK search for the word "Wort" 

--

# Metacharacters

- **.** matches any character: "W.rt" finds Wort, Wert, Wart, Wbrt, W$rt, W2rt, W rt...
- **[]** matches the characters within []: "W[oe]rt" finds Wort and Wert
- **\d** matches any single digit: 0, 1, 2, 3, 4, 5, 6, 7, 8, 9
- **\D** matches any single character that is NOT a digit
- **\w** matches any part of word character
- **\W** matches any part that is NOT word character (,;|_?...)
- **\s** matches any space, tab, or newline
	- **\n** new line
	- **\t** Tabulator

--

### Metacharacters

- **.** matches any character: "W.rt" finds Wort, Wert, Wart, Wbrt, W$rt, W2rt, W rt...
- **[]** matches the characters within []: "W[oe]rt" finds Wort and Wert
- **\d** matches any single digit: 0, 1, 2, 3, 4, 5, 6, 7, 8, 9
- **\w** matches any part of word character
- **\s** matches any space, tab, or newline

### Exercise
* Find BK classes with "Garten" or "Gärten" <!--G[aä]rten-->
* Find BK classes with "Museum" or "Museen" <!--Muse[eu][nm]-->
* Find BK classes only with "Garten" or "Gärten" at the end of some word (i.e. Kindergarten) <!--\wg[aä]rten-->
* Find BK classes that start with "Technik" (i.e. 50.00 Technik allgemein: Allgemeines) <!--\d\d;\sTechnik-->

--

# Backslash

* When we want to search for the actual character and not using it as metacharacter
* **\**
* To escape the metacharacter
* Examples:
	* \\.
	* \\[
	* \\-
	* \\*
	* \\?

## Exercise
* Search for "7." and not for "70"

--

# Character ranges

* When using **`-`** within **`[]`**, we can cover ranges of characters
* Examples
	* `[a-z]` (= `[abcdefghijklmnopqrstuvwxyz]`)
	* `[A-Za-z]`	 
	* `[0-9]` ( = `[0123456789]` = `\d`)
	* `[a-zA-0-9]` (= `\w`)

## Exercises
* BK Klassen für germanische Sprachen <!--18\.-->
* BK Klassen für Literaturwissenschaft <!--17\.[7-9]\d-->
<!--* GOK-Klassen Textausgaben von allen germanischen Sprachen	 <!--H[R-W]\w 610-->

--

# Flags

* Match case
* . matches newline

Find "garten" and not "Garten"

--

# Quantifiers
* `?` matches when the preceding character appears zero or one time. Example: For example, ab?c matches “ac” and “abc”. 
* `*` matches the preceding element zero or more times. For example, ab*c matches “ac”, “abc”, “abbbc”, etc. (further option: "*?" = "*" not greedy)
* `+` matches the preceding element one or more times. For example, ab*c matches “abc”, “abbbc” but not “ac”. (further option: "+?"  = "+" not greedy)
* `{VALUE}` matches the preceding character the number of times define by VALUE; ranges can be specified with the syntax {VALUE,VALUE}
* `|` means or. For example, ab|ac matches “ab” and “ac” 

--

# Quantifiers
* `?` matches when the preceding character appears zero or one time
* `*` matches the preceding element zero or more times
* `+` matches the preceding element one or more times
* `{VALUE}` matches the preceding character the number of times define by VALUE; ranges can be specified with the syntax {VALUE,VALUE}
* `|` means or.

## Exercise
* Find "Wort", "Worte" or "Wörter" <!--W[oö]rte?r?-->
* Find "Wörter" or "Woerter" using [] and a quantifier<!--W[oeö]+rter-->
* Find "Garten" or "Gärten" using | <!--Garten|Gärten-->

--


# Anchors

- **`^`** asserts the position at the start of the line. So what you put after it will only match if they are the first characters of a line.
- **`$`** asserts the position at the end of the line. So what you put before it will only match if they are the last characters of a line.
- **`\b`** adds a word boundary. Putting this either side of a word stops the regular expression matching longer variants of words. So:
- Examples:
	* the regular expression foobar will match foobar and find 666foobar, foobar777, 8thfoobar8th et cetera
    * the regular expression \bfoobar will match foobar and find foobar777
    * the regular expression foobar\b will match foobar and find 666foobar
    * the regular expression \bfoobar\b will find foobar

--

# Anchors

- **`^`** asserts the position at the start of the line
- **`$`** asserts the position at the end of the line
- **`\b`** adds a word boundary

## Exercises
* Search for a class that DOES NOT start with a number
* Search for classs starting with 17
* Find words with "Garten" or "Gärten" at the beginning
* Find words with "Garten" or "Gärten" at the end
* Search for the words "Garten" or "Gärten" as independent words

--

# Congrats, now you have super powers!

---


# 5. Regular Expressions (Replace)

--

# These silly changes...

* We have this:
	* 01.10; Bibliographie: Allgemeines
	* 01.11; Allgemeinbibliographien|Universalbibliographien
* We want this:
	* Bibliographie: Allgemeines: 01.10
	* Allgemeinbibliographien|Universalbibliographien: 01.11
* Do we change the 2089 cases one by one?

--

# No, now you can regex!

--

# Replace
* Ctr + H in Notepad++
	* Find what:
	* Replace with

--

# Grouping

* With () we can create groups. Example (\d\d\.\d\d)
* This groups can be used for replacing text, using \1, \2, \3, etc.


--

* Find what: ^(\d\d\.\d\d); (.*?)$
* Replace with: \2: \1

--

# Data
* 7-052 Niederdeutsch-SUB-Nova_20210709.xlsx
* Column "Verfasser"
* Example: Thies, Johannes *1904-1992* ; ID: gnd/1053242913

--

## Example
* Get surname
	* Find what: "^(.+),\s(.+)$"
* Replace with \1\t\2

--

## Exercise

* Get first name

* Find what: "^(.+), (.+?)(\*\d.*?$|$)"
* Replace with \2			

--

Get date of birth

--
## Exercise

Get first name
Get date of birth
Get date of death
get gnd identifier
Get everything at once


---


				
					</script>
				</section>
            </div>
        </div>

        <script src="../../lib/reveal/dist/reveal.js"></script>
        <script src="../../lib/reveal/plugin/zoom/zoom.js"></script>
        <script src="../../lib/reveal/plugin/notes/notes.js"></script>
        <script src="../../lib/reveal/plugin/search/search.js"></script>
        <script src="../../lib/reveal/plugin/markdown/markdown.js"></script>
        <script src="../../lib/reveal/plugin/highlight/highlight.js"></script>
        <script>
    
          // Also available as an ES module, see:
          // https://revealjs.com/initialization/
          Reveal.initialize({
            controls: true,
            progress: true,
            center: true,
            hash: true,
    
            // Learn about plugins: https://revealjs.com/plugins/
            plugins: [ RevealZoom, RevealNotes, RevealSearch, RevealMarkdown, RevealHighlight ]
          });
    
        </script>
    
      </body>
    </html>
    